/*	__________________________________________________
                                C S   1 2 1
          W O R K I N G   W I T H   P O I N T E R S
		     A N D   D Y N A M I C   M E M O R Y
		                             
		                       Ron Kessler
		                Created 10/25/2016

This app shows how to work with the heap.
Use Ctl-F5 because I changed the fonts/colors
https://www.youtube.com/watch?v=W0aE-w61Cb8	Intro to pointers
https://www.youtube.com/watch?v=CSVRA4_xOkw  Creating variables on the heap
	__________________________________________________
*/

#include "stdafx.h"
#include<stdio.h>					//so we can use printf
#include<memory>

using namespace System;


//---sample class so we can access items in the heap
ref class Customers
{
public:
	int numItems;


};




int main()
{

	Console::WriteLine("Let's make an int on the unmanaged heap using a pointer. (int *p = new int;) Then add 5 to that address (*p=5).\n\n");
    //---STEP 1:  create a simple variable on the unmanaged heap and a pointer to hold its address
	int *p = new int;
	
	
	//---STEP 2: add 5 to the new int location
	*p = 5;

	Console::WriteLine("Now let's read the value in memory using the dereference operator (*p).\n\n");
	Console::WriteLine("Value at that address is " + *p);
	Console::ReadKey();

	//---STEP 3: deallocate to avoid creating garbage
	delete p;	//this is still pointing to the old location. This is a dangling pointer.
	p = nullptr;		//sets p = 0 & cleans up.

	Console::Clear();
	Console::WriteLine("Now we create another pointer and initialize the address to 10: p = new int(10);");
	Console::ReadKey();
	

	//---STEP 4: create another new int on the heap using our same pointer
	p = new int(10);		//now our pointer is pointing to the new int we made. It can no longer access the first int.
									// the first int is now garbage

	Console::WriteLine("Now let's read the value in memory using the dereference operator (*p).\n\n");
	Console::WriteLine("Value at that address is " + *p);
	Console::ReadKey();

	p = nullptr;				//clean up
	//****************************************************************
	
	//STEP 5: create an instance of the customer class and access numItems with an interior pointer.
	
	Console::Clear();
	Console::WriteLine("Now create an instance of the customer class and access numItems with an interior pointer..\n\n");

	Customers^ whichCustomer = gcnew Customers();
	whichCustomer->numItems = 105;				//set initial value
	
	interior_ptr<int> x = &(whichCustomer->numItems);		//get address of numItems
	Console::Write ("\nVariable numItems is stored at ");
	printf("%x" , x);			//print hex address of x
	Console::ReadKey ();

	
	//---now use the pointer to add 50 to numItems using the "ContentsOf" operator (*)
	Console::WriteLine("\n\nNow we use the pointer to add 50 more to numItems. We use numItems = *x + 50 ");

	Console::Write("\nThe variable numItems is now *x + 50  which = ");
	Console::WriteLine(whichCustomer->numItems = *x + 50);


	Console::ReadKey();

	x = nullptr;
	return 0;
}
